#!/bin/bash

pkg=`echo $2 |awk -F \= '{print $2}'`
#检查是否有desktop文件，没有的不运行
tmppkg=$pkg
#处理packagename中的大写字母转小写和下划线_转中划线-
low_package_name=`echo $tmppkg | tr "[:upper:]" "[:lower:]"`
tmppkg=`echo $low_package_name | sed -e "s/_/-/g" `
desktop="/usr/share/applications/uengine.$tmppkg.desktop"
if [ ! -f $desktop ]; then
    user_apk_desktop="$HOME/.local/share/applications/uengine/uengine.apk.$pkg.desktop" #APK安装工具生成的
    desktop_o="/usr/share/applications/uengine.$pkg.desktop" #最初上架的应用可能desktop文件名和pkg名一至,没转成小写
    if [ ! -f $user_apk_desktop  -a ! -f $desktop_o ]; then
        osver=`cat /etc/os-version |grep "EditionName=" | head -n1 | awk -F '=' '{print $2}'`
        if [ "$osver" != 'Community' ]; then
            echo "The Desktop file is not found, cannot open app."
            exit 0;
        fi
    fi
fi

pkgRunCnt=`ps -ef |grep "uengine launch" |grep -v grep |grep "$pkg" |wc -l`
if [ $pkgRunCnt -ge 1 ]; then
    #防止短时间内多次打开同一应用，如果应用正在启动中，此次忽略
    exit 0
fi

#等Session服务启动完全
wscont=0
isReady=`busctl --user get-property org.anbox /org/anbox org.anbox.ApplicationManager Ready`
if [ "$isReady" != "b true" ] ;then
    sleep 2
fi
while [ "$isReady" = "b false" -a $wscont -lt 10 ]
do
    sleep 1
    isReady=`busctl --user get-property org.anbox /org/anbox org.anbox.ApplicationManager Ready`
    let wscont++
done

uengine launch $*
