#!/bin/bash

#执行apt update 和 apt policy获取最新的版本
#$1=1表示要执行update,否则不执行update
if [ "$1" = "1" ]; then
   #先执行update
   apt update > "/tmp/apt_update.log"
fi

aptpolicylog="/tmp/apt_uengine_ver.txt"
apt policy uengine > $aptpolicylog

now_ver=`sed -n "2p" $aptpolicylog | awk '{print $2}'`
if test -z "$now_ver"; then
   #可能中文版本 没有空格使用中文的“：”
   now_ver=`sed -n "2p" $aptpolicylog | awk -F "：" '{print $2}'`
fi

new_ver=`sed -n "3p" $aptpolicylog | awk '{print $2}'`

function version_gt() { test "$(echo "$@" | tr " " "\n" | sort -V | head -n 1)" != "$1"; }

#比较版本号判断是否要更新0：不更新，1：更新
is_new=0
if [ "${new_ver:0:1}" != "(" ]; then
   if version_gt $new_ver $now_ver; then
      is_new=1
   fi
fi

echo "$now_ver,$new_ver,$is_new" # 脚本返回值，请勿在其它地方使用echo 
