#!/bin/sh

echo "start runnable check..."

#检查CPU是否支持UENGINE
#uengine check-features
if [ -f "/usr/share/uengine/cpunotsupport" ]; then
    echo "The CPU of your computer does not support UEngine."
    /usr/share/uengine/uengine-check-msg cpu-chk
    exit 100
fi

#检查是否是多用户登录运行
session_pid=`ps -ef |grep 'uengine session-manager' | grep -v grep | awk '{print $2}' |head -n 1` #获取session-manager用户
session_uid=`cat /proc/$session_pid/status |grep Uid |awk '{print $2}'`
curr_login_id=`id | cut -d '=' -f 2 | awk -F '(' '{print $1}'`
echo "session_user_id:$session_uid"
echo "curr_user_id:$curr_login_id"

user_ok="yes"
if [ "$session_uid" != "" -a "$curr_login_id" != "" -a "$session_uid" != "$curr_login_id" ]; then
    user_ok="no"
fi
if [ "$user_ok" = "no" ]; then
    if [ -d "/data/uengine/data" ]; then
        first_user=`ls -l /data/uengine/data |grep -w data |awk '{print $3}'`   #获取data的所属用户
    fi
    echo "first_user:$first_user"
    session_user=`ps -ef |grep 'uengine session-manager' | grep -v grep | awk '{print $1}' |head -n 1`
    echo "session_user:$session_user"
    run_user=$session_user
    if test -z "$run_user"; then
        run_user=$first_user
    fi
    echo "UEngine does not support multi-user login operation, please run Android in [$run_user] user."
    login_user=`logname`
    if test -z "$login_user" ; then #logname为空可能是服务启动不弹提示
        exit 100
    fi
    /usr/share/uengine/uengine-check-msg user-chk $run_user
    if [ $? -eq 1 ]; then
        echo "open Logout window."
        dbus-send --print-reply --session --type=method_call --dest=com.deepin.dde.shutdownFront /com/deepin/dde/shutdownFront com.deepin.dde.shutdownFront.Logout
    fi

    exit 100
fi

echo "Check OK"
exit 0
